//////////////////////////////////////////////////
// File: TkelvinThread.cpp
// Author: Kelvin Sung
// Date: April 2003
// 
// This example shows how to use CEvent to support
// synchronization between the main thread and each worker thread
// to do work together.
//
//
//
#include "TkelvinThread.h"

#include <iostream.h>
#include <iomanip.h>
			// for cout/cin/cerr, and i/o formatting

#include <fstream.h>
			// for ostream
			
#include <process.h>
			// for _beginthread and _endthread

//
// #inlcude <afxmt.h>
//			// for MFC synchronization objects: CMutex/CEvent
//	

//
// To Compile: for Both Debug and Release:
//    Must include compiler optins: /MT /D "_X86_"
//
// To Link: 
//          For Debug Must include:   LIBCMTD.lib and MSVCRTD.lib
//			For Release Must include: LibCMT.LIB and MSVCRT.LIB
//
//    NAFXCWD.lib (NAFXCW.LIB for Release) must appear _BEFORE_ LIBCMTD.LIB)
//
//
//

static void KelvinThread(void *parm)
	//
	// Check via TsyncObject:
	//
	//    Wakes up and sleep, calls
	//
	// 		TsyncObject->KelvinStartWork() and
	//		TsyncObject->KelvinEndWork()
	//
	//  to stop student threas doing useful work
	//
{
	TkelvinThread *td = (TkelvinThread *) parm;
	ofstream &os = td->OutStream();
	TsyncObject &sync = TworkerThread::GetSyncObject();

	sync.KelvinStartWork();
		// this function will make sure no future student can do work

		td->GotNewJob();
		os << "Kelvin Working on job (" << td->NumJob() <<")" << endl;
		os.flush();

		td->ThreadWorkTime();
		os << "	Done    on job (" << td->NumJob() << ")" << endl;

	sync.KelvinEndWork();

	_endthread();
}

///////////////////////////////////////////////////////////////////////////////////////
//
// TworkerThread methods
//
/////////////////////////////////////////////////////////////////////////////////////

void
TkelvinThread::StartThread()
{
	_beginthread(KelvinThread, 0, (void *) this );
}
