////////////////////////////////////////////////////////////////
//
// file: TthreadBase.h
// Author: Kelvin Sung
// Date: April 2003
//
//
//  TbaseThread: a somewhat general thread base class suitable for 
//  	subclass to override and do a little more.
//
#ifndef TTHREAD_BASE_H
#define TTHREAD_BASE_H

#include <fstream.h >
			// for ostream


#define kNameSize	20


class TthreadBase {
	protected:
		char		fName[kNameSize];		// name of this thread
		int			fID;					// id of this thread
		ofstream	*fOutStream;			// output stream

		int			fWorkTime;				// Assume this the time this thread
											// would need to finish the work
	public:

		TthreadBase(char *name, int id, int tm);
				// Constructor

		const char* ThreadName() const { return fName; }
		const int ThreadID() const { return fID; }


		ofstream& OutStream() { return *fOutStream; }
				// output stream for this thread;

		int  WorkTime() { return fWorkTime; }

		void ThreadWorkTime();
				// artificially delay the response time of this thread
				// or else all threads runs too fase and we cannot
				// figure out what is going on.

		virtual void StartThread();
				// This will start the thread. Subclasses should
				// override this method to begin their own threads
				// 
};
#endif

