////////////////////////////////////////////////////////////////
//
// file: TworkerThread.h
// Author: Kelvin Sung
// Date: April 2003
//
//
//  TworkerThread: very dumb worker class, which only
//  	do work when the main thread tells it to do work.
//
//	Implementation: Subclass from TbaseThread
//
//	Communicates with the main thread based on TsyncObject
//
//
#ifndef TWORKER_THREAD_H
#define TWORKER_THREAD_H

#include "TsyncObject.h"
			// for TsyncObject
			//
#include "TthreadBase.h"


class TworkerThread : public TthreadBase {
	protected:
		static		TsyncObject sfSyncObj;		
						// this is a _CLASS_ variable
						// class variable means there is only
						// one copy of this variable for all objects
						// of this class to share
						//
						// All TworkerThread objects will use this
						// TsyncObject to coordinate with main thread
		
		int			fNumJob;

	public:

		static TsyncObject& GetSyncObject() { return sfSyncObj; }
				// class method
				//

		TworkerThread(char *name, int id, int tm) :
			TthreadBase(name, id, tm), fNumJob(0) {}

		void GotNewJob() { fNumJob++; }
		int NumJob() const { return fNumJob; }

		virtual void StartThread();
				// override this to start our own thread ...
				// 
};
#endif
