///////////////////////////////////////////////////////////////////////
//
// File: test.cpp
// Author: Kelvin Sung
// Date: April, 2003
//
//
//
//   1. Starts 3 student threads (id = 0-2) each with short working time
//
//   2. Poll the user to start KelvinThread, 
//			if kelvinThread had started, student threads should 
//			wait for kelvin thread done before continue again
// 
//   3. when input is -1, quit all threads.
//
// 
#include <iostream.h>

#include "TworkerThread.h"
#include "TkelvinThread.h"

#include <Windows.h>


#define kNumWorkers 3

int main() {

	TsyncObject &sync = TworkerThread::GetSyncObject();
	TkelvinThread *kelvinThread = new TkelvinThread("KelvinThread", 10, 10 /* sleep time of 10 sec */);	

	int sleepTimes[kNumWorkers] = {2, 2, 2};

	cout << "Sync Tests Workers=[1-5] Times=[2, 2, 2]" << endl;

	//
	// Start all the worker threads ...
	//
	for (int i=0; i<kNumWorkers; i++) {
		TworkerThread *wk = new TworkerThread("StudentThread", i, sleepTimes[i]);
		wk->StartThread();
	}

	int cmd=0;	// 0 - to start KelvinThread, -1 to quit
	while (cmd >= 0) {

		cout << "[0 - to start KelvinThread, -1 to quit]: ";
		cin >> cmd;

		if (cmd == 0) {
			// start KelvinThread: 
			kelvinThread->StartThread();
		}
	}

	sync.SetTerminateAll();

	Sleep((long)3000);
		// wait 3 seconds, making sure all worker threads are done before
		// quit.

	cout << "Total time spend working by all student threads: " << sync.TotalWorkTime()/1000 << " Seconds." << endl;
	return 0;
}
